Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Choice

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Choice

All Implemented Interfaces:
  Accessible, ImageObserver, ItemSelectable, MenuContainer, Serializable

public class Choice
extends Component
implements ItemSelectable, Accessible

The `Choice` class presents a pop-up menu of choices. The current choice is displayed as the title of the menu.

The following code example produces a pop-up menu:

>      Choice ColorChooser = new Choice();
>      ColorChooser.add("Green");
>      ColorChooser.add("Red");
>      ColorChooser.add("Blue");

After this choice menu has been added to a panel, it appears as follows in its normal state:

In the picture, `"Green"` is the current choice. Pushing the mouse button down on the object causes a menu to appear with the current choice highlighted.

Some native platforms do not support arbitrary resizing of Choice components and the behavior of setSize()/getSize() is bound by such limitations. Native GUI Choice components' size are often bound by such attributes as font size and length of items contained within the Choice.

Since:
  JDK1.0
See Also:
  Serialized Form

Inner Class Summary
`protected class` | `Choice.AccessibleAWTChoice` This class implements accessibility support for the `Choice` class.

Inner classes inherited from class java.awt.Component
`Component.AccessibleAWTComponent`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`Choice()` Creates a new choice menu.

Method Summary
`void` | `add(String item)` Adds an item to this `Choice` menu.
`void` | `addItem(String item)` Adds an item to this Choice.
`void` | `addItemListener(ItemListener l)` Adds the specified item listener to receive item events from this `Choice` menu.
`void` | `addNotify()` Creates the Choice's peer.
`int` | `countItems()` Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.
`AccessibleContext` | `getAccessibleContext()` Gets the AccessibleContext associated with this Choice.
`String` | `getItem(int index)` Gets the string at the specified index in this `Choice` menu.
`int` | `getItemCount()` Returns the number of items in this `Choice` menu.
`EventListener[]` | `getListeners(Class listenerType)` Return an array of all the listeners that were added to the Choice with addXXXListener(), where XXX is the name of the `listenerType` argument.
`int` | `getSelectedIndex()` Returns the index of the currently selected item.
`String` | `getSelectedItem()` Gets a representation of the current choice as a string.
`Object[]` | `getSelectedObjects()` Returns an array (length 1) containing the currently selected item.
`void` | `insert(String item, int index)` Inserts the item into this choice at the specified position.
`protected String` | `paramString()` Returns the parameter string representing the state of this choice menu.
`protected void` | `processEvent(AWTEvent e)` Processes events on this choice.
`protected void` | `processItemEvent(ItemEvent e)` Processes item events occurring on this `Choice` menu by dispatching them to any registered `ItemListener` objects.
`void` | `remove(int position)` Removes an item from the choice menu at the specified position.
`void` | `remove(String item)` Remove the first occurrence of `item` from the `Choice` menu.
`void` | `removeAll()` Removes all items from the choice menu.
`void` | `removeItemListener(ItemListener l)` Removes the specified item listener so that it no longer receives item events from this `Choice` menu.
`void` | `select(int pos)` Sets the selected item in this `Choice` menu to be the item at the specified position.
`void` | `select(String str)` Sets the selected item in this `Choice` menu to be the item whose name is equal to the specified string.

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addPropertyChangeListener, addPropertyChangeListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentOrientation, getCursor, getDropTarget, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getInputContext, getInputMethodRequests, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getName, getParent, getPeer, getPreferredSize, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isDisplayable, isDoubleBuffered, isEnabled, isFocusTraversable, isLightweight, isOpaque, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, reshape, resize, resize, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFont, setForeground, setLocale, setLocation, setLocation, setName, setSize, setSize, setVisible, show, show, size, toString, transferFocus, update, validate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Choice

    public Choice()

  Creates a new choice menu. The menu initially has no items in it.

  By default, the first item added to the choice menu becomes the selected item, until a different selection is made by the user by calling one of the `select` methods.

  See Also:
    `select(int)`, `select(java.lang.String)`

Method Detail

### addNotify

    public void addNotify()

  Creates the Choice's peer. This peer allows us to change the look of the Choice without changing its functionality.
  Overrides:
    `addNotify` in class `Component`
  See Also:
    `Toolkit.createChoice(java.awt.Choice)`, `Component.getToolkit()`

### getItemCount

    public int getItemCount()

  Returns the number of items in this `Choice` menu.
  Since:
    JDK1.1
  See Also:
    `getItem(int)`

### countItems

    public int countItems()

  Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.

### getItem

    public String getItem(int index)

  Gets the string at the specified index in this `Choice` menu.
  Parameters:
    `index` - the index at which to begin.
  See Also:
    `getItemCount()`

### add

    public void add(String item)

  Adds an item to this `Choice` menu.
  Parameters:
    `item` - the item to be added
  Throws:
    `NullPointerException` - if the item's value is `null`.
  Since:
    JDK1.1

### addItem

    public void addItem(String item)

  Adds an item to this Choice.
  Parameters:
    `item` - the item to be added
  Throws:
    `NullPointerException` - If the item's value is equal to null.

### insert

    public void insert(String item,
                       int index)

  Inserts the item into this choice at the specified position.
  Parameters:
    `item` - the item to be inserted
    `index` - the position at which the item should be inserted
  Throws:
    `IllegalArgumentException` - if index is less than 0.

### remove

    public void remove(String item)

  Remove the first occurrence of `item` from the `Choice` menu.
  Parameters:
    `item` - the item to remove from this `Choice` menu.
  Throws:
    `IllegalArgumentException` - if the item doesn't exist in the choice menu.
  Since:
    JDK1.1

### remove

    public void remove(int position)

  Removes an item from the choice menu at the specified position.
  Parameters:
    `position` - the position of the item.
  Since:
    JDK1.1

### removeAll

    public void removeAll()

  Removes all items from the choice menu.
  Since:
    JDK1.1
  See Also:
    `remove(java.lang.String)`

### getSelectedItem

    public String getSelectedItem()

  Gets a representation of the current choice as a string.
  Returns:
    a string representation of the currently selected item in this choice menu.
  See Also:
    `getSelectedIndex()`

### getSelectedObjects

    public Object[] getSelectedObjects()

  Returns an array (length 1) containing the currently selected item. If this choice has no items, returns null.
  Specified by:
    `getSelectedObjects` in interface `ItemSelectable`
  See Also:
    `ItemSelectable`

### getSelectedIndex

    public int getSelectedIndex()

  Returns the index of the currently selected item.
  See Also:
    `getSelectedItem()`

### select

    public void select(int pos)

  Sets the selected item in this `Choice` menu to be the item at the specified position.
  Parameters:
    `pos` - the positon of the selected item.
  Throws:
    `IllegalArgumentException` - if the specified position is invalid.
  See Also:
    `getSelectedItem()`, `getSelectedIndex()`

### select

    public void select(String str)

  Sets the selected item in this `Choice` menu to be the item whose name is equal to the specified string. If more than one item matches (is equal to) the specified string, the one with the smallest index is selected.
  Parameters:
    `str` - the specified string
  See Also:
    `getSelectedItem()`, `getSelectedIndex()`

### addItemListener

    public void addItemListener(ItemListener l)

  Adds the specified item listener to receive item events from this `Choice` menu. If l is null, no exception is thrown and no action is performed.
  Specified by:
    `addItemListener` in interface `ItemSelectable`
  Parameters:
    `l` - the item listener.
  Since:
    JDK1.1
  See Also:
    `ItemEvent`, `ItemListener`, `removeItemListener(java.awt.event.ItemListener)`

### removeItemListener

    public void removeItemListener(ItemListener l)

  Removes the specified item listener so that it no longer receives item events from this `Choice` menu. If l is null, no exception is thrown and no action is performed.
  Specified by:
    `removeItemListener` in interface `ItemSelectable`
  Parameters:
    `l` - the item listener.
  Since:
    JDK1.1
  See Also:
    `ItemEvent`, `ItemListener`, `addItemListener(java.awt.event.ItemListener)`

### getListeners

    public EventListener[] getListeners(Class listenerType)

  Return an array of all the listeners that were added to the Choice with addXXXListener(), where XXX is the name of the `listenerType` argument. For example, to get all of the ItemListener(s) for the given Choice `c`, one would write:

       ItemListener[] ils = (ItemListener[])(c.getListeners(ItemListener.class))

  If no such listener list exists, then an empty array is returned.
  Overrides:
    `getListeners` in class `Component`
  Parameters:
    `listenerType` - Type of listeners requested
  Returns:
    all of the listeners of the specified type supported by this choice
  Since:
    1.3

### processEvent

    protected void processEvent(AWTEvent e)

  Processes events on this choice. If the event is an instance of `ItemEvent`, it invokes the `processItemEvent` method. Otherwise, it calls its superclass's `processEvent` method.
  Overrides:
    `processEvent` in class `Component`
  Parameters:
    `e` - the event.
  Since:
    JDK1.1
  See Also:
    `ItemEvent`, `processItemEvent(java.awt.event.ItemEvent)`

### processItemEvent

    protected void processItemEvent(ItemEvent e)

  Processes item events occurring on this `Choice` menu by dispatching them to any registered `ItemListener` objects.

  This method is not called unless item events are enabled for this component. Item events are enabled when one of the following occurs:

  - An `ItemListener` object is registered via `addItemListener`.
  - Item events are enabled via `enableEvents`.
  Parameters:
    `e` - the item event.
  Since:
    JDK1.1
  See Also:
    `ItemEvent`, `ItemListener`, `addItemListener(java.awt.event.ItemListener)`, `Component.enableEvents(long)`

### paramString

    protected String paramString()

  Returns the parameter string representing the state of this choice menu. This string is useful for debugging.
  Overrides:
    `paramString` in class `Component`
  Returns:
    the parameter string of this `Choice` menu.

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Gets the AccessibleContext associated with this Choice. For Choice components, the AccessibleContext takes the form of an AccessibleAWTChoice. A new AccessibleAWTChoice instance is created if necessary.
  Specified by:
    `getAccessibleContext` in interface `Accessible`
  Overrides:
    `getAccessibleContext` in class `Component`
  Returns:
    an AccessibleAWTChoice that serves as the AccessibleContext of this Choice

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.